--- chan_sip.c.orig     2005-02-17 11:41:23.000000000 -0400
+++ chan_sip.c  2005-02-17 11:49:02.000000000 -0400
@@ -3265,6 +3265,7 @@
        char newto[256];
        char *c, *n;
        char *ot, *of;
+       int is_strict=0;

        memset(req, 0, sizeof(struct sip_request));

@@ -3279,17 +3280,24 @@
                p->branch ^= rand();
                build_via(p, p->via, sizeof(p->via));
        }
+
+       /* check if next hop is a strict router */
+       if ((p->route) && (!ast_strlen_zero(p->route->hop))
+                       && (strstr(p->route->hop,";lr")==NULL) ) {
+               is_strict=1;
+       }
+
        if (!strcasecmp(msg, "CANCEL")) {
                c = p->initreq.rlPart2; /* Use original URI */
        } else if (!strcasecmp(msg, "ACK")) {
                /* Use URI from Contact: in 200 OK (if INVITE)
                (we only have the contacturi on INVITEs) */
                if (!ast_strlen_zero(p->okcontacturi))
-                       c = p->okcontacturi;
+                       c = is_strict?p->route->hop:p->okcontacturi;
                else
                        c = p->initreq.rlPart2;
        } else if (!ast_strlen_zero(p->okcontacturi)) {
-               c = p->okcontacturi; /* Use for BYE or REINVITE */
+               c = is_strict?p->route->hop:p->okcontacturi;    /* Use for BYE or REINVITE */
        } else if (!ast_strlen_zero(p->uri)) {
                c = p->uri;
        } else {
@@ -3318,7 +3326,13 @@
        add_header(req, "Via", p->via);
        if (p->route) {
                set_destination(p, p->route->hop);
-               add_route(req, p->route->next);
+               if (is_strict) {
+                       /* first route is already at URI */
+                       add_route(req, p->route->next);
+               } else {
+                       /* All route must be present according to RFC3261 */
+                       add_route(req, p->route);
+               }
        }

        ot = get_header(orig, "To");

